/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.antrax.storage.enums.CdrDropReason;
import com.flamesgroup.storage.convert.CdrDropReasonConverter;
import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.convert.IccidConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.CallPathRecord;
import com.flamesgroup.unit.ICCID;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CallPath extends TableImpl<CallPathRecord> {

	private static final long serialVersionUID = 125147734;

	/**
	 * The reference instance of <code>public.call_path</code>
	 */
	public static final CallPath CALL_PATH = new CallPath();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<CallPathRecord> getRecordType() {
		return CallPathRecord.class;
	}

	/**
	 * The column <code>public.call_path.id</code>.
	 */
	public final TableField<CallPathRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.call_path.cdr_id</code>.
	 */
	public final TableField<CallPathRecord, Long> CDR_ID = createField("cdr_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

	/**
	 * The column <code>public.call_path.sim_device_uid</code>.
	 */
	public final TableField<CallPathRecord, Integer> SIM_DEVICE_UID = createField("sim_device_uid", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.call_path.sim_channel_num</code>.
	 */
	public final TableField<CallPathRecord, Short> SIM_CHANNEL_NUM = createField("sim_channel_num", org.jooq.impl.SQLDataType.SMALLINT, this, "");

	/**
	 * The column <code>public.call_path.gsm_device_uid</code>.
	 */
	public final TableField<CallPathRecord, Integer> GSM_DEVICE_UID = createField("gsm_device_uid", org.jooq.impl.SQLDataType.INTEGER, this, "");

	/**
	 * The column <code>public.call_path.gsm_channel_num</code>.
	 */
	public final TableField<CallPathRecord, Short> GSM_CHANNEL_NUM = createField("gsm_channel_num", org.jooq.impl.SQLDataType.SMALLINT, this, "");

	/**
	 * The column <code>public.call_path.iccid</code>.
	 */
	public final TableField<CallPathRecord, ICCID> ICCID = createField("iccid", org.jooq.impl.SQLDataType.CLOB, this, "", new IccidConverter());

	/**
	 * The column <code>public.call_path.gsm_group_name</code>.
	 */
	public final TableField<CallPathRecord, String> GSM_GROUP_NAME = createField("gsm_group_name", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.call_path.sim_group_name</code>.
	 */
	public final TableField<CallPathRecord, String> SIM_GROUP_NAME = createField("sim_group_name", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.call_path.cdr_drop_reason</code>.
	 */
	public final TableField<CallPathRecord, CdrDropReason> CDR_DROP_REASON = createField("cdr_drop_reason", org.jooq.impl.SQLDataType.CLOB, this, "", new CdrDropReasonConverter());

	/**
	 * The column <code>public.call_path.start_time</code>.
	 */
	public final TableField<CallPathRecord, Date> START_TIME = createField("start_time", org.jooq.impl.SQLDataType.TIMESTAMP, this, "", new DateConverter());

	/**
	 * The column <code>public.call_path.cdr_drop_code</code>.
	 */
	public final TableField<CallPathRecord, Short> CDR_DROP_CODE = createField("cdr_drop_code", org.jooq.impl.SQLDataType.SMALLINT.nullable(false).defaulted(true), this, "");

	/**
	 * Create a <code>public.call_path</code> table reference
	 */
	public CallPath() {
		this("call_path", null);
	}

	/**
	 * Create an aliased <code>public.call_path</code> table reference
	 */
	public CallPath(String alias) {
		this(alias, CALL_PATH);
	}

	private CallPath(String alias, Table<CallPathRecord> aliased) {
		this(alias, aliased, null);
	}

	private CallPath(String alias, Table<CallPathRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<CallPathRecord, Long> getIdentity() {
		return Keys.IDENTITY_CALL_PATH;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<CallPathRecord> getPrimaryKey() {
		return Keys.CALL_PATH_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<CallPathRecord>> getKeys() {
		return Arrays.<UniqueKey<CallPathRecord>>asList(Keys.CALL_PATH_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<ForeignKey<CallPathRecord, ?>> getReferences() {
		return Arrays.<ForeignKey<CallPathRecord, ?>>asList(Keys.CALL_PATH__CALL_PATH_CDR_FKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CallPath as(String alias) {
		return new CallPath(alias, this);
	}

	/**
	 * Rename this table
	 */
	public CallPath rename(String name) {
		return new CallPath(name, null);
	}
}
